# -*- coding: utf-8 -*-

from setuphelpers import *
import datetime

uninstallkey=[]

def install():

    versionpaquet = control['version'].split('-',1)[0]
    install_exe_if_needed('PyScripter-%s-x86-Setup.exe' % versionpaquet,'/VERYSILENT',key='PyScripter_is1',min_version=versionpaquet,killbefore=['PyScripter'])

    for prof in local_users_profiles():
        if not 'ServiceProfiles' in prof:
            if isdir(makepath(prof,'AppData','Roaming')):
                fixconfigpyscripter(makepath(prof,'AppData','Roaming'))

    if not installed_softwares('putty'):
        print('Please Install Putty for use ssh in pyscripter')



def session_setup():
    fixconfigpyscripter(application_data())

def fixconfigpyscripter(prof):
    profilpy = makepath(prof,'PyScripter')
    if not isdir(profilpy):
        mkdirs(profilpy)
    if not isfile(makepath(profilpy,"PyScripter.local.ini")):
        inifile_writestring(makepath(profilpy,"PyScripter.local.ini"),'PythonVersions-x86','InstallPath',install_location('WAPT_is1'))
        inifile_writestring(makepath(profilpy,"PyScripter.local.ini"),r'PythonVersions-x86\Custom Versions','Path0',install_location('WAPT_is1'))
        inifile_writestring(makepath(profilpy,"PyScripter.local.ini"),r'PythonVersions-x86\Custom Versions','Count',"0")
    if not isfile(makepath(profilpy,"PyScripter.ini")):
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'Other Settings','Style Name',"Windows10")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','AutoCompleteBrackets',"FALSE")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','NewFileEncoding',"sf_UTF8_NoBOM")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','PythonEngineType',"peRemote")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','SSHCommand',"plink")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','SSHOptions',"-batch -P 22")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','ScpCommand',"pscp")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','ScpOptions',"-batch -P 22")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','SSHDisableVariablesWin',"TRUE")
        inifile_writestring(makepath(profilpy,"PyScripter.ini"),r'IDE Options','AlwaysUseSockets','TRUE')

def update_package():

    import requests
    url = requests.head('https://sourceforge.net/projects/pyscripter/files/latest/download?source=files',proxies={}).headers['Location']
    dstexe = requests.head(url,proxies={}).headers['Location'].replace('.zip','-Setup.exe').replace('-x64','-x86')
    filename = dstexe.rsplit('/',1)[1]
    vers = filename.split('-')[1].replace('v','')
    print ("Latest Version : " + vers)

    exes = glob.glob('*.exe')
    for fn in exes:
        if fn != filename:
            remove_file(fn)

    if not isfile(filename):
        print('Downloading %s from %s'%(filename,dstexe))
        wget(dstexe,filename)
    else:
        print('Already up to date, skipped')

    control.version = vers + '-0'
    control.save_control_to_wapt()

